%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Script that compiles the mex wrappers for isinf implementation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Insert your own path to isinf here
source_dir = ['/home/dbatra/research/3D_segmentation/code/common_code/planar_inference/isinf-1.0_mac']; 

source_dir_s = [source_dir '/src'];
source_dir_b = [source_dir '/blossomV'];
%source_dir_b_int = [source_dir '/blossom5-v2.01.src'];
source_dir_b_int = [source_dir '/blossomV_int'];
source_dir_p = [source_dir '/planarity'];

% embed
PLANARITY = {'graphEmbed.o' 'graphNonplanar.o' 'graphTests.o' 'graphIO.o' 'stack.o' 'graphPreprocess.o' 'listcoll.o' ...
             'graphIsolator.o' 'graphStructure.o'};
for i=1:length(PLANARITY)
  PLANARITY2{i} = sprintf('%s/src/%s ',source_dir,PLANARITY{i});
end

if ~exist(['embed_mex.' mexext],'file')
  fprintf(['mex embed_mex.cpp ' cell2mat(PLANARITY2) ' -I' source_dir ' -output embed_mex\n\n']);
  eval(['mex embed_mex.cpp ' cell2mat(PLANARITY2) ' -I' source_dir ' -output embed_mex']);
end

% map
BLOSSOMV = {'PMduals.cpp' 'PMrepair.cpp' 'PMexpand.cpp' 'PMshrink.cpp' 'PMinit.cpp' 'PMinterface.cpp' ...
            'PMmain.cpp' 'misc.cpp' 'MinCost.cpp'};
for i=1:length(BLOSSOMV)-1
  BLOSSOMV2{i} = sprintf('%s/blossomV/%s ',source_dir,BLOSSOMV{i});
  %BLOSSOMV2_int{i} = sprintf('%s/blossom5-v2.01.src/%s ',source_dir,BLOSSOMV{i});
  BLOSSOMV2_int{i} = sprintf('%s/blossomV_int/%s ',source_dir,BLOSSOMV{i});
end
BLOSSOMV2{i+1} = sprintf('%s/blossomV/MinCost/%s ',source_dir,BLOSSOMV{i+1});
%BLOSSOMV2_int{i+1} = sprintf('%s/blossom5-v2.01.src/MinCost/%s ',source_dir,BLOSSOMV{i+1});
BLOSSOMV2_int{i+1} = sprintf('%s/blossomV_int/MinCost/%s ',source_dir,BLOSSOMV{i+1});

% map
if ~exist(['map_mex.' mexext],'file')
  fprintf(['mex -DTIMER_DEFINED map_mex.cpp ' cell2mat(BLOSSOMV2) ' -I' source_dir_s  ' -I' source_dir_b ' -I' source_dir_p  ' -output map_mex\n\n']);
  eval(['mex -DTIMER_DEFINED map_mex.cpp ' cell2mat(BLOSSOMV2) ' -I' source_dir_s  ' -I' source_dir_b ' -I' source_dir_p  ' -output map_mex']);
end

% map_el
if ~exist(['map_el_mex.' mexext],'file')
  fprintf(['mex -DTIMER_DEFINED map_el_mex.cpp ' cell2mat(BLOSSOMV2) cell2mat(PLANARITY2) ' -I' source_dir_s  ' -I' source_dir_b ' -I' source_dir_p  ' -output map_el_mex\n\n']);
  eval(['mex -DTIMER_DEFINED map_el_mex.cpp ' cell2mat(BLOSSOMV2) cell2mat(PLANARITY2) ' -I' source_dir_s  ' -I' source_dir_b ' -I' source_dir_p  ' -output map_el_mex']);
end


% min_marg
if ~0%exist(['min_marg_mex.' mexext],'file')
  fprintf(['mex -DTIMER_DEFINED min_marg_mex.cpp ' cell2mat(BLOSSOMV2) ' -I' source_dir_s  ' -I' source_dir_b ' -I' source_dir_p  ' -output min_marg_double_mex\n\n']);
  eval(['mex -DTIMER_DEFINED min_marg_mex.cpp ' cell2mat(BLOSSOMV2) ' -I' source_dir_s  ' -I' source_dir_b ' -I' source_dir_p  ' -output min_marg_double_mex']);
end

% min_marg_int
if ~exist(['min_marg_int_mex.' mexext],'file')
  fprintf(['mex -DTIMER_DEFINED min_marg_mex.cpp ' cell2mat(BLOSSOMV2_int) ' -I' source_dir_s  ' -I' source_dir_b_int ' -I' source_dir_p  ' -output min_marg_int_mex\n\n']);
  eval(['mex -DTIMER_DEFINED min_marg_mex.cpp ' cell2mat(BLOSSOMV2_int) ' -I' source_dir_s  ' -I' source_dir_b_int ' -I' source_dir_p  ' -output min_marg_int_mex']);
end

% min_marg_el_int
if ~exist(['min_marg_el_int_mex.' mexext],'file')
  fprintf(['mex -DTIMER_DEFINED min_marg_el_mex.cpp ' cell2mat(BLOSSOMV2_int) cell2mat(PLANARITY2) ' -I' source_dir_s  ' -I' source_dir_b_int ' -I' source_dir_p  ' -output min_marg_el_int_mex\n\n']);
  eval(['mex -DTIMER_DEFINED min_marg_el_mex.cpp ' cell2mat(BLOSSOMV2_int) cell2mat(PLANARITY2) ' -I' source_dir_s  ' -I' source_dir_b_int ' -I' source_dir_p  ' -output min_marg_el_int_mex']);
end

% ne_mm_el_int
if ~exist(['ne_mm_el_int_mex.' mexext],'file')
  fprintf(['mex -g -DTIMER_DEFINED ne_mm_el_mex.cpp ' cell2mat(BLOSSOMV2_int) cell2mat(PLANARITY2) ' -I' source_dir_s  ' -I' source_dir_b_int ' -I' source_dir_p  ' -output ne_mm_el_int_mex\n\n']);
  eval(['mex -g -DTIMER_DEFINED ne_mm_el_mex.cpp ' cell2mat(BLOSSOMV2_int) cell2mat(PLANARITY2) ' -I' source_dir_s  ' -I' source_dir_b_int ' -I' source_dir_p  ' -output ne_mm_el_int_mex']);
end
